﻿using Newtonsoft.Json;
using Newtonsoft.Json.Serialization;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Threading.Tasks;

namespace HeuristicLab.Clients.Hive.WebJobManager.Services
{
    /// <summary>
    /// Throws some properties out to save on bandwidth space while refreshing 
    /// the selected job
    /// </summary>
    public class JsonTaskResolver : DefaultContractResolver
    {
        protected override JsonProperty CreateProperty(MemberInfo member,
                                            MemberSerialization memberSerialization)
        {
            JsonProperty property = base.CreateProperty(member, memberSerialization);
            if (property.PropertyName == "ItemImage" ||
                property.PropertyName == "Parameters" ||
                property.PropertyName == "OperatorGraph" ||
                property.PropertyName == "DistanceMatrix" ||
                property.PropertyName == "Operators" ||
                property.PropertyName == "Engine" ||
                property.PropertyName == "ActualValue" ||
                property.PropertyName == "CurrentScope" ||
                property.PropertyName == "Problems" ||
                property.PropertyName == "Random" ||
                property.PropertyName == "Optimizer" ||
                property.PropertyName == "Optimizers" ||
                property.PropertyName == "Problem" ||
                property.PropertyName == "NestedOptimizers")
            {
                property.ShouldSerialize = instanceOfProblematic => false;
            }

            return property;
        }
    }

}
